package io.tswf.minecraft.metamorphosis.cpw.modlauncher

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.minecraft.metamorphosis.core.remap.ITinyRemapperConfigurationListener
import io.tswf.minecraft.metamorphosis.core.remap.TinyRemappingAdapter

@AutoService(ITinyRemapperConfigurationListener)
@CompileStatic
class Forge1_20_1_TinyRemapperConfigurer implements ITinyRemapperConfigurationListener {

    public static final int PRIORITY = 1

    public static final String SRG_NAMESPACE_NAME = "srg"
    public static final String NAMED_NAMESPACE_NAME = "named"
    public static final String MAPPINGS_1_20_1_LOCATION = "mappings/tiny/1.20.1/mappings-srg-1.20.1.tiny"

    @Override
    void onTinyRemapperConfigurationStarts() {
        def remapper = TinyRemappingAdapter.theRemapper
        TinyRemappingAdapter.namespaceTo = remapper.dstNamespaces.indexOf(SRG_NAMESPACE_NAME)
        TinyRemappingAdapter.namespaceFrom = remapper.dstNamespaces.indexOf(NAMED_NAMESPACE_NAME)
        TinyRemappingAdapter.mappingsLocation = MAPPINGS_1_20_1_LOCATION
    }

    @Override
    int getPriority() {
        return PRIORITY
    }
}
